import random
import pygame

from quit import *
def delay(miliseconds):
    if hasQuit():
        return
    for x in xrange(0, miliseconds/100):
        for e in pygame.event.get():
            if e.type == pygame.QUIT:
                postQuit()
                return
        pygame.time.wait(miliseconds/10)

def damage_formula(attacker, defender, attack_card, defense_card):
    attack_value  = attacker.stats["attack"]
    defense_value = attacker.stats["defense"]
    if attack_card == "S":
        multiplier = 15
        if attacker.stats["mp"] >= 5:
            mp_consumption = 5
        else:
            mp_consumption = attacker.stats["mp"]
        attacker.stats["mp"] -= mp_consumption
        multiplier += 3 * mp_consumption
        multiplier = float(multiplier) / 10
        print "Multiplier is ", multiplier
        attribute = attacker.stats["special"]
        attack_value  += attacker.stats[attribute]
        defense_value += defender.stats[attribute]
    if attack_card == "A":
        multiplier = 1.5
    else:
        multiplier = 1.0
    if defense_card == "D":
        multiplier *= 0.5
    result = int(((attack_value * 3) - (defense_value))*multiplier)
    if result <= 0:
        result = 1
    return result


def card_index(c):
    '''I am going to hell for writing this function.'''
    if c == "A": return 10
    if c == "D": return 11
    if c == "S": return 12
    return c - 1

def attack_wins(attack_card, defense_card):
    '''This is a boolean function that tells you whether your programming skills
    suck or not.

    Note: This function is not working as documented. For some reason it does
    not return True every time I call it. Maybe it's because I wrote it and my
    programming skill sucks.'''
    if attack_card == "S": return True
    if attack_card == "A" and defense_card != "D": return True
    if attack_card == "D":  return False
    if attack_card == None: return False
    return attack_card > defense_card

def best_attack_card(cards):
    '''Abandon hope all who enter here'''
    if len(cards) == 0: return None
    if "S" in cards: return "S"
    if "A" in cards: return "A"
    if 10  in cards: return 10
    if  9  in cards: return  9
    if  8  in cards: return  8
    if  7  in cards: return  7
    if  6  in cards: return  6
    if  5  in cards: return  5
    if  4  in cards: return  4
    if  3  in cards: return  3
    if  2  in cards: return  2
    if  1  in cards: return  1
    return "D"

def worst_defense_card(cards):
    if len(cards) == 0: return None
    if  1  in cards: return  1
    if  2  in cards: return  2
    if  3  in cards: return  3
    if  4  in cards: return  4
    if  5  in cards: return  5
    if  6  in cards: return  6
    if  7  in cards: return  7
    if  8  in cards: return  8
    if  9  in cards: return  9
    if 10  in cards: return 10
    if "A" in cards: return "A" #Those are left for last, even if they are bad
    if "S" in cards: return "S" #because I don't want the computer to be dumb.
    return "D" #This line should never be executed. Should raise exception instead.
    

def best_defense_card(cards):
    '''I used to like good structuring of source-code until I wrote this.'''
    if len(cards) == 0: return None
    if "D" in cards: return "D"
    if 10  in cards: return 10
    if  9  in cards: return  9
    if  8  in cards: return  8
    if  7  in cards: return  7
    if  6  in cards: return  6
    if  5  in cards: return  5
    if  4  in cards: return  4
    if  3  in cards: return  3
    if  2  in cards: return  2
    if  1  in cards: return  1
    if "A" in cards: return "A"
    return "S"

def complete_cards(cards):
    if len(cards) < 6:
        deck = [1,2,3,4,5,6,7,8,9,10,"A","D","S"]
        for c in cards:
            deck.remove(c)
        n = 6 - len(cards)
        cards.extend(random.sample(deck, n))
        cards.sort()

def has_unit(units, p):
    for u in units:
        if u.position == p:
            return True
    return False

def path_find(battle, unit):
    '''Hell'''
    targets = battle.player_units.values()
    allies  = battle.enemy_units.values()
    grid    = battle.battleground.grid
    ps = []
    ds = []
    for u in targets:
        ps.append(u.position)
        ds.append(0)
    i = 0
    while i < len(ps):
        x = ps[i][0]
        y = ps[i][1]
        d = ds[i]+1
        if x > 1:
            point = (x-1, y)
            if point not in ps:
                if not grid.isSolid(point):
                    ps.append(point)
                    ds.append(d)
        if x < 19:
            point = (x+1, y)
            if point not in ps:
                if not grid.isSolid(point):
                    ps.append(point)
                    ds.append(d)
        if y > 1:
            point = (x, y-1)
            if point not in ps:
                if not grid.isSolid(point):
                    ps.append(point)
                    ds.append(d)
        if y < 14:
            point = (x, y+1)
            if point not in ps:
                if not grid.isSolid(point):
                    ps.append(point)
                    ds.append(d)
        i += 1

    pf = flood_fill(unit, unit.position, battle, unit.stats["speed"])
    for p in pf:
        if has_unit(allies, p):
            pf.remove(p)
    pf.append(unit.position)
    d = 1000
    best = None
    for p in pf:
        if p in ps:
            i = ps.index(p)
            if ds[i] < d:
                d = ds[i]
                best = i
    if best:
        return ps[best]
    
    

def flood_fill(unit, position, battle, speed):
    '''This function was written to make you cry.'''
    grid = battle.battleground.grid
    if unit.player == True:
        for u in battle.enemy_units.values():
            if position == u.position:
                return []
    else:
        for u in battle.player_units.values():
            if position == u.position:
                return []

    if grid.isSolid(position):
        return []
    if speed == 0:
        return [position]
    result  = [position]
    new_pos = (position[0]-1, position[1])
    for x in flood_fill(unit, new_pos, battle, speed-1):
        if x not in result:
            result.append(x)
    new_pos = (position[0], position[1]-1)
    for x in flood_fill(unit, new_pos, battle, speed-1):
        if x not in result:
            result.append(x)
    new_pos = (position[0]+1, position[1])
    for x in flood_fill(unit, new_pos, battle, speed-1):
        if x not in result:
            result.append(x)
    new_pos = (position[0], position[1]+1)
    for x in flood_fill(unit, new_pos, battle, speed-1):
        if x not in result:
            result.append(x)
    return result

